<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: game.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">game.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef V1_1_GAME_H</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define V1_1_GAME_H</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;cmap.h&quot;</span>   <span class="comment">//also includes entities.h, coords.h, config.h</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define MAX_SCORE 10000</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno"><a class="line" href="classquit.html">    9</a></span>&#160;<span class="keyword">class </span><a class="code" href="classquit.html">quit</a>{};</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classCGame.html">   15</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCGame.html">CGame</a> {</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keywordtype">int</span>                                  m_score;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordtype">int</span>                                  m_attackersTotal;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keywordtype">string</span>                               m_mapFolder;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <a class="code" href="classCMap.html">CMap</a>                                 m_gamePlan;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    vector &lt; pair &lt;CTower *,    int &gt; &gt;  m_towers;      </div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="classCGame.html#adb78984d62a00d886e66ebdebd63d84e">   22</a></span>&#160;    vector &lt; pair &lt;CAttacker *, int &gt; &gt;  <a class="code" href="classCGame.html#adb78984d62a00d886e66ebdebd63d84e">m_attackers</a>;   </div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">bool</span>    parseLine    ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; line );</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">bool</span>    parseSave    ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; line );</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">bool</span>    loadEntities ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; filename );</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">bool</span>    readNextMove ( <span class="keywordtype">void</span> );</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">void</span>    moveAndPrint ( <span class="keywordtype">void</span> );</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">bool</span>    loadSavedGame( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; filename);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span>    saveScore    () <span class="keyword">const</span>;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">friend</span>  ostream &amp; operator&lt;&lt; (ostream &amp;os, <span class="keyword">const</span> <a class="code" href="classCGame.html">CGame</a> &amp;game);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <a class="code" href="classCGame.html">CGame</a>       ( <span class="keywordtype">void</span> ): m_score(0), m_attackersTotal (0) {}</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            <a class="code" href="classCGame.html">CGame</a>       ( <span class="keyword">const</span> <a class="code" href="classCGame.html">CGame</a> &amp; src ) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            ~<a class="code" href="classCGame.html">CGame</a>();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span>    operator =  ( <span class="keyword">const</span> <a class="code" href="classCGame.html">CGame</a> &amp; src ) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">bool</span>    loadGame    ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; filename, <span class="keywordtype">bool</span> newGame );</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">bool</span>    saveGame    ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; outfile );</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">bool</span>    play        ( <span class="keywordtype">void</span> );</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;};</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#endif //V1_1_GAME_H</span></div><div class="ttc" id="classCGame_html"><div class="ttname"><a href="classCGame.html">CGame</a></div><div class="ttdoc">CGame represents the game with its engine, gamePlan, entities, etc... </div><div class="ttdef"><b>Definition:</b> game.h:15</div></div>
<div class="ttc" id="classquit_html"><div class="ttname"><a href="classquit.html">quit</a></div><div class="ttdoc">used for exception only </div><div class="ttdef"><b>Definition:</b> game.h:9</div></div>
<div class="ttc" id="classCMap_html"><div class="ttname"><a href="classCMap.html">CMap</a></div><div class="ttdoc">This class represents a map ( game plan ) with all game objects and entities ( attacker / tower / pat...</div><div class="ttdef"><b>Definition:</b> cmap.h:11</div></div>
<div class="ttc" id="classCGame_html_adb78984d62a00d886e66ebdebd63d84e"><div class="ttname"><a href="classCGame.html#adb78984d62a00d886e66ebdebd63d84e">CGame::m_attackers</a></div><div class="ttdeci">vector&lt; pair&lt; CAttacker *, int &gt; &gt; m_attackers</div><div class="ttdoc">All loaded tower templates ( parents ) </div><div class="ttdef"><b>Definition:</b> game.h:22</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
